	FUNCTION DDNEXT (OLDDIR, NEWDIR)

C This function is part of the DEFAULT package

C Author:	Joseph L. BINGHAM
C		ManTech International
C		2320 Mill Road
C		Alexandira, VA 22314
C		(703) 838-5600

C This function finds the next first level directory on the disk.  It 
C   uses DNEXT after incrementing the root directory.

C Parameters are as in DNEXT.

	IMPLICIT INTEGER (A-Z)
	CHARACTER *(*) OLDDIR, NEWDIR

	LHB = MAX (INDEX (OLDDIR, '['), INDEX (OLDDIR ,'<'))

	RHDELIM = MIN (INDEX (OLDDIR // ']', ']'),
	1	INDEX (OLDDIR // '>', '>'), INDEX (OLDDIR // '.', '.'))

	IF (RHDELIM - LHB .LT. 10) THEN

		OLDDIR (RHDELIM:) = '0]'

	ELSE

		RM1 = RHDELIM - 1
		OLDDIR (RM1:) = CHAR (ICHAR (OLDDIR (RM1:RM1)) + 1) // ']'

	ENDIF
	DDNEXT = DNEXT (OLDDIR, NEWDIR)

	RETURN

	END
