        SET NOVERIFY
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     RESUME.COM                                                     !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     RESUME ALL NON-SYSTEM PROCESSES AFTER SYSTEM MAINTENANCE       !
$ !--------------------------------------------------------------------!
$ !     THIS PROCEDURE FILE RESUMES ALL ACTIVE NON-SYSTEM PROCESSES    !
$ !     WITHIN THE OPERATING SYSTEM AFTER A SHUTDOWN OR OTHER          !
$ !     MAINTENANCE FUNCTION.  THE HEART OF THIS CAPABILITY IS IN THE  !
$ !     'SUSPEND' AND 'RESUME' UTILITIES WHICH RESPECTIVELY SUSPEND    !
$ !     AND RESUME A GIVEN PROCESS BY PROCESS NAME OR HEX PROCESS ID.  !
$ !--------------------------------------------------------------------!
$       ON CONTROL_Y THEN GOTO ABORT
$       ON ERROR THEN GOTO ABORT
$       ON WARNING THEN GOTO ABORT
$       SET NOON
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  SYSTEM RESUMPTION UTILITY  ***"
$       WRITE SYS$OUTPUT " "
$ !--------------------------------------------------------------------!
$ !     SEARCH SYSTEM PROCESSES AND RESUME USER PROCESSES              !
$ !--------------------------------------------------------------------!
$       OPEN PROCESS SUSPEND.DAT /READ /ERROR=NOTSUSP
$ !
$ GETPROCESS:
$       READ PROCESS PRCDAT /END=NOMOREPROC
$       PRCPID:='F$EXTRACT(1,8,PRCDAT)'
$ !--------------------------------------------------------------------!
$ !     RESUME THE USER PROCESS                                        !
$ !--------------------------------------------------------------------!
$       RESUME 'PRCPID'
$       GOTO GETPROCESS
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     NO MORE PROCESS TO RESUME - RETURN CONTROL TO USER             !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ NOMOREPROC:
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  SYSTEM RESUMPTION COMPLETE  ***"
$       CLOSE PROCESS
$       DELETE SUSPEND.DAT;*
$       EXIT
$ !--------------------------------------------------------------------!
$ !     ERROR EXIT                                                     !
$ !--------------------------------------------------------------------!
$ ABORT:
$       CLOSE PROCESS
$       DELETE SUSPEND.DAT;*
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  PROCEDURE ABORTED BY OPERATOR  ***"
$       EXIT
$ !--------------------------------------------------------------------!
$ !     ERROR CONDITION:     SYSTEM NOT IN SUSPENDED STATE             !
$ !--------------------------------------------------------------------!
$ NOTSUSP:
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  SYSTEM NOT PREVIOUSLY SUSPENDED  ***"
$ !--------------------------------------------------------------------!
$ !     END OF PROCEDURE RESUME.COM                                    !
$ !--------------------------------------------------------------------!
